<template lang="pug">
div
  centered-settings
    //- Left pane is a sticking menu that allow to quickly jump from section to section
    div.columns.settings-left-pane#left-pane
      //- Sticking div ; see https://github.com/eddiemf/vue-affix#usage
      affix(relative-element-selector="#left-pane" style="width:20vw;max-width:200px;")
        div.accordion
          input(type="checkbox" id="accordion-user" name="accordion-checkbox" hidden checked disabled)
          label.accordion-header.text-bold(for="accordion-user") {{ $tc('user', 1) | capitalize }}
          div.accordion-body
            ul.menu.menu-nav
              li.menu-item
                a(v-scroll-to="'#profile'" ref="profile") {{ $t('profile') }} <z-icon tabindex="-1" name="account_circle"/>
              li.menu-item
                a(v-scroll-to="'#history'" ref="history") {{ $t('history') }} <z-icon tabindex="-1" name="history"/>
              li.menu-item
                a(v-scroll-to="'#export'" ref="export") Import and export <z-icon tabindex="-1" name="unarchive"/>
        div.accordion(v-if="isAdministrator")
          input(type="checkbox" id="accordion-administration" name="accordion-checkbox" hidden checked disabled)
          label.accordion-header.text-bold(for="accordion-administration") {{ $t('administration') }}
          div.accordion-body
            ul.menu.menu-nav
              li.menu-item
                a(v-scroll-to="'#dashboard'" ref="dashboard") {{ $t('dashboard') | capitalize }} <z-icon tabindex="-1" name="dashboard"/>
              li.menu-item
                a(v-scroll-to="'#server-parameters'" ref="server-parameters") Server parameters <z-icon tabindex="-1" name="settings"/>
              li.menu-item
                a(v-scroll-to="'#federation'" ref="federation") Federation <z-icon tabindex="-1" name="explore"/>
              li.menu-item
                a(v-scroll-to="'#users'" ref="users") {{ $tc('user', 2) | capitalize }} <z-icon tabindex="-1" name="supervisor_account"/>
        div.accordion(v-if="isModerator")
          input(type="checkbox" id="accordion-moderation" name="accordion-checkbox" hidden checked disabled)
          label.accordion-header.text-bold(for="accordion-moderation") {{ $t('moderation') }}
          div.accordion-body
            ul.menu.menu-nav
              li.menu-item
                a(v-scroll-to="'#reports'" ref="reports") {{ $tc('report', 2) | capitalize }} <z-icon tabindex="-1" name="report"/>
              li.menu-item
                a(v-scroll-to="'#new-corpora'" ref="new-corpora") {{ $t('new', { thing: $tc('corpus', 2) }) | capitalize }} <z-icon tabindex="-1" name="local_library"/>
        
      back-to-top(bottom="50px" right="75%" visibleoffset="800")
        button.btn.btn-action.s-circle(style="margin-right:0.8rem;").
          #[i.material-icons(tabindex="-1" style="transform:rotate(-90deg)") chevron_right]

    //- Right pane is just a continuous page stacking all administration sections
    div.columns.settings-right-pane(ref="rightpane")
      //- Standard user
      profile-edit#profile(v-observe-visibility="{ callback: visibilityChanged, intersection: intersectionOptions, throttle: 300 }")
      user-preferences
      history#history(v-observe-visibility="{ callback: visibilityChanged, intersection: intersectionOptions, throttle: 300 }")
      export-user-data#export(v-observe-visibility="{ callback: visibilityChanged, intersection: intersectionOptions, throttle: 300 }")
      //- Administrator only
      div(v-if="isAdministrator")
        dashboard#dashboard(v-observe-visibility="{ callback: visibilityChanged, intersection: intersectionOptions, throttle: 300 }")
        server-parameters#server-parameters(v-observe-visibility="{ callback: visibilityChanged, intersection: intersectionOptions, throttle: 300 }")
        federation#federation(v-observe-visibility="{ callback: visibilityChanged, intersection: intersectionOptions, throttle: 300 }")
        user-list#users(v-observe-visibility="{ callback: visibilityChanged, intersection: intersectionOptions, throttle: 300 }")
      //- Moderator only
      div(v-if="isModerator")
        report-list#reports(v-observe-visibility="{ callback: visibilityChanged, intersection: intersectionOptions, throttle: 300 }")
        new-corpora-list#new-corpora(v-observe-visibility="{ callback: visibilityChanged, intersection: intersectionOptions, throttle: 300 }")
</template>

<script>
import { mapGetters } from 'vuex'
import { Affix } from 'vue-affix'
import BackToTop from 'vue-backtotop'

import lazyLoadComponent from '~/utilities/lazy-load-component.js'
import CenteredSettings from '~/components/sublayouts/CenteredSettings.vue'
import ProfileEdit from '~/components/ProfileEdit.vue'
import SkeletonBox from '~/components/SkeletonBox.vue'

const defaultOptions = {
  loading: SkeletonBox,
  loadingData: {
    props: {
      width: `100%`,
      height: `20em`
    }
  }
}

export default {
  middleware: ['isAuth', 'isSetup'],
  components: {
    CenteredSettings,
    Affix,
    BackToTop,
    ProfileEdit,
    UserPreferences: lazyLoadComponent({
      ...defaultOptions,
      componentFactory: () => import('~/components/UserPreferences.vue')
    }),
    History: lazyLoadComponent({
      ...defaultOptions,
      componentFactory: () => import('~/components/History.vue')
    }),
    ExportUserData: lazyLoadComponent({
      ...defaultOptions,
      componentFactory: () => import('~/components/ExportUserData.vue')
    }),
    UserList: lazyLoadComponent({
      ...defaultOptions,
      componentFactory: () => import('~/components/UserList.vue')
    }),
    Dashboard: lazyLoadComponent({
      ...defaultOptions,
      componentFactory: () => import('~/components/Dashboard.vue')
    }),
    ServerParameters: lazyLoadComponent({
      ...defaultOptions,
      componentFactory: () => import('~/components/ServerParameters.vue')
    }),
    Federation: lazyLoadComponent({
      ...defaultOptions,
      componentFactory: () => import('~/components/Federation.vue')
    }),
    ReportList: lazyLoadComponent({
      ...defaultOptions,
      componentFactory: () => import('~/components/ReportList.vue')
    }),
    NewCorporaList: lazyLoadComponent({
      ...defaultOptions,
      componentFactory: () => import('~/components/NewCorporaList.vue')
    })
  },
  data() {
    return {
      stickingStyles: {
        'padding-top': ''
      },
      intersectionOptions: {
        root: this.$refs.rightpane,
        rootMargin: '10%',
        threshold: 0.6 // [0.25, 0.75] if you want a 25% offset!
      } // https://developer.mozilla.org/en-US/docs/Web/API/Intersection_Observer_API
    }
  },
  computed: {
    ...mapGetters('user', ['isAdministrator', 'isModerator'])
  },
  mounted() {
    setTimeout(() => this.scrollFix(), 300)
  },
  methods: {
    visibilityChanged(isVisible, entry) {
      /* this is used to toggle the active links in the menu */
      isVisible
        ? (this.$refs[entry.target.id].className = 'active')
        : this.$refs[entry.target.id].classList.remove('active')
    },
    scrollFix() {
      if (this.$route.hash) {
        const el = document.getElementById(this.$route.hash.slice(1))
        if (el) {
          window.scrollTo(0, el.offsetTop)
        }
      }
    }
  }
}
</script>

<style lang="postcss" scoped>
.columns {
  flex-direction: column;
}

.settings-left-pane {
  text-align: right;
}

.settings-right-pane {
  box-shadow: -20px 0 10px -10px rgba(0, 0, 0, 0.06);
}

.accordion {
  width: 100%;
}

.menu.menu-nav {
  min-width: unset;
}

li.menu-item > a {
  display: flex;
  justify-content: right;
  align-items: center;
  flex: 1;

  & i {
    margin-left: 0.3rem;
  }
}

.card:not(:first-child) {
  margin-top: 20px;
}

a:hover:not(.active) {
  background: inherit !important;
}
</style>
